/*
 * Copyright 2019 The Netty Project
 *
 * The Netty Project licenses this file to you under the Apache License, version 2.0 (the
 * "License"); you may not use this file except in compliance with the License. You may obtain a
 * copy of the License at:
 *
 * https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
package io.netty.handler.codec.http2;

import io.netty.channel.ChannelHandler;

public class Http2MultiplexHandlerClientUpgradeTest extends Http2MultiplexClientUpgradeTest<Http2FrameCodec> {

    @Override
    protected Http2FrameCodec newCodec(ChannelHandler upgradeHandler) {
        return Http2FrameCodecBuilder.forClient().build();
    }

    @Override
    protected ChannelHandler newMultiplexer(ChannelHandler upgradeHandler) {
        return new Http2MultiplexHandler(new NoopHandler(), upgradeHandler);
    }
}
